#ifndef _H_EVENTS_LOOP_P
#define _H_EVENTS_LOOP_P

#include "common.h"

#if __GLIBC__ > 2 ||  (__GLIBC__ == 2 && __GLIBC_MINOR__ >= 8)
#define USING_EVENT_FD
#endif

class EventWrapper;

class EventsLoop_p {
public:
    void remove_wrapper(EventWrapper*);

public:
    int _epoll;
    typedef std::list<EventWrapper*> Events;
    Events _events;

    friend class EventWrapper;
};

class Trigger_p {
public:
    Trigger_p() : _pending_int (false) {}
    int get_fd(){ return _event_fd;}
    bool reset_event();

public:
    int _event_fd;
#ifndef USING_EVENT_FD
    int _event_write_fd;
#endif
    bool _pending_int;
    Mutex _lock;
};

#endif


