#include "common.h"
#include "red_pixmap.h"
#include "debug.h"
#include "utils.h"

RedPixmap::RedPixmap(int width, int height, RedPixmap::Format format,
                     bool top_bottom, rgb32_t* pallet)
    : _format (format)
    , _width (width)
    , _height (height)
    , _stride (ALIGN(width * (_format == RedPixmap::A1 ? 1 : 32), 32) / 8)
    , _top_bottom (top_bottom)
    , _data (NULL)
{
}

RedPixmap::~RedPixmap()
{   
}

bool RedPixmap::is_big_endian_bits()
{
    return false;
}

